<template>
  <div class="service_plans">
    <ul class="service_plan_list">
      <li v-for="plan in plans" v-bind:key="plan.id" class="service_plan">
        <h3 class="service_plan__name title is-4">{{ plan.name }}</h3>
        <h3
          v-if="plan.free"
          class="subtitle is-5 service_plan__cost_amount"
        >{{ $data._.get(plan, 'metadata.costs[0].unit', '$') }}0/transaction</h3>
        <h3 v-else class="subtitle is-5 service_plan__cost_amount">$10</h3>
        <h3
          v-if="$data._.get(plan, 'metadata.costs[0].unit')"
          class="service_plan__cost_unit"
        >{{ plan.metadata.costs[0].unit }}</h3>
        <h3 v-else class="service_plan__cost_unit"></h3>
        <hr />
        <p class="service_plan__description">{{ plan.description }}</p>
        <!-- Currently no bullets so provide placeholders for now -->
        <ul v-if="plan.metadata && plan.metadata.bullets" class="service_plan__bullets content">
          <li
            v-for="bullet in plan.metadata.bullets"
            v-bind:key="bullet"
            class="service_plan_bullet"
          >{{ bullet }}</li>
        </ul>
        <ul v-else class="service_plan__bullets content">
          <li class="service_plan_bullet">Unlimited Use</li>
          <li class="service_plan_bullet">Unified Arbalo Billing</li>
          <li class="service_plan_bullet">Fast provisioning</li>
          <li class="service_plan_bullet">Simple Integration</li>
        </ul>
        <button
          class="button service_plan__button is-success has-text-white has-text-weight-bold"
          v-on:click="provision(plan.id)"
        >Provision</button>
      </li>
    </ul>
  </div>
</template>

<script lang="ts">
import { Component, Vue, Prop } from "vue-property-decorator";
import { ServicePlan } from "@/services/osb/catalog";
import _ from "lodash";

@Component
export default class ServiceOfferingPlan extends Vue {
  // Setting lodash here to be used for complex lookups in template
  _ = _;

  @Prop() public serviceId!: string;
  @Prop() public plans!: ServicePlan[];

  provision(planID: string) {
    if (!this.$keycloak.authenticated) {
      this.$keycloak.login();
    }
    this.$store.dispatch("catalog/provision", {
      serviceID: this.serviceId,
      projectUUID: this.$store.state.activeProject.uuid,
      planID
    });
  }
}
</script>

<style lang="scss" scoped>
$white: white;

.service_plan_list {
  display: flex;
  flex-wrap: wrap;
  flex-direction: column;
  justify-content: center;
  align-content: center;

  @include media(">tablet") {
    flex-direction: row;
  }
}

.service_plans {
  margin-top: 25px;
}

.service_plan {
  display: flex;
  justify-content: center;
  align-content: center;
  flex-direction: column;
  background-color: $white;
  width: 100%;
  text-align: center;
  padding: 10px;

  &__cost_amount {
    margin: unset !important;
  }

  &__button {
    height: 44px;
    margin: 0 50px;
  }

  @include media(">tablet") {
    width: 300px;
    margin-right: 15px;

    &:last-child {
      margin-right: unset;
    }

    &__button {
      height: auto;
    }
  }
}
</style>
